﻿-- 当前聊天窗口标签透明度.
-- 系统默认值为 1 和 0.4.
CHAT_FRAME_TAB_SELECTED_MOUSEOVER_ALPHA = 1		--鼠标停留时
CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 0		--鼠标未停留时

-- 聊天窗口标签闪动时的透明度.
-- 系统默认值为 1 和 1.
CHAT_FRAME_TAB_ALERTING_MOUSEOVER_ALPHA = 1		--鼠标停留时
CHAT_FRAME_TAB_ALERTING_NOMOUSE_ALPHA = 1       --鼠标未停留时

-- 其他聊天窗口标签不闪动时的透明度.
-- Defaults are 0.6 and 0.2.
CHAT_FRAME_TAB_NORMAL_MOUSEOVER_ALPHA = 0.6		--鼠标停留时
CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0         --鼠标未停留时


-- 隐藏社交按钮(3.55新增的好友按钮)

function AshChat_FMB(fmb)
	if fmb then
		FriendsMicroButton:ClearAllPoints()
		FriendsMicroButton:SetPoint("TOPLEFT", "ChatFrame1", "TOPLEFT", -32, 32)
		FriendsMicroButton:SetPoint("BOTTOMRIGHT", "ChatFrame1", "TOPLEFT", 0, 0)
		FriendsMicroButton:EnableDrawLayer()
	else
		FriendsMicroButton:ClearAllPoints()
		FriendsMicroButton:SetPoint("TOPRIGHT", "ChatFrame1", "TOPRIGHT", -34, 0)
		FriendsMicroButton:SetPoint("BOTTOMLEFT", "ChatFrame1", "TOPRIGHT", -66, -31)
		FriendsMicroButton:DisableDrawLayer()
	end
end

if AshChatDB.showfmb == nil then
	AshChatDB.showfmb = false
end

AshChat_FMB(AshChatDB.showfmb)

for i = 1, 7 do
	--使你可以任意调整聊天窗口尺寸
	local cf = _G[format("%s%d", "ChatFrame", i)]
	cf:SetMinResize(0,0)
	cf:SetMaxResize(0,0)

	--使聊天窗口可以任意移动,去除靠边时的限制
	cf:SetClampRectInsets(0,0,0,0)

	--启用输入文字时用方向键直接移动光标的功能
	--local eb =  _G[format("%s%d%s", "ChatFrame", i, "EditBox")]
	--eb:SetAltArrowKeyMode(false)
end

-- 隐藏右下角的箭头,直接拖动边框以调整聊天窗口大小
-- all-edges resize controls (disable-on-lock stuff comes from Tekkub's tekChatBorderFix)
local anchorPoints = { "TopLeft", "TopRight", "BottomLeft", "BottomRight", "Top", "Right", "Left", "Bottom" }

local function ChatFrame_StartResizing(self)
	local chatFrame = self:GetParent()
	if chatFrame.isLocked then return end
	if chatFrame.isDocked and chatFrame ~= DEFAULT_CHAT_FRAME then return end

	chatFrame.resizing = 1
	chatFrame:StartSizing(self.anchorPoint)
end

local function ChatFrame_StopResizing(self)
	local chatFrame = self:GetParent()
	chatFrame:StopMovingOrSizing()
	if chatFrame == DEFAULT_CHAT_FRAME then
		FCF_DockUpdate()
	end
	chatFrame.resizing = nil
	FCF_SavePositionAndDimensions(self:GetParent())	--test
end

local oldSetChatWindowLocked = SetChatWindowLocked
function SetChatWindowLocked (index, locked, ...)
	local f = _G["ChatFrame"..index]
	for _, v in ipairs(anchorPoints) do
		local k = "resize" .. v
		if f[k] then
			f[k]:EnableMouse(not locked)
		end
	end
	return oldSetChatWindowLocked (index, locked, ...)
end

for i = 1, 10 do
	local f = _G["ChatFrame"..i]
	if not f.resizeTopLeft then
		f.background = _G["ChatFrame"..i.."Background"]

		for _, v in ipairs(anchorPoints) do
			local k = "resize" .. v
			f[k] = CreateFrame("Button", "ChatFrame" .. i .. "Resize" .. v, f)
			f[k].anchorPoint = v:upper()
			f[k]:SetWidth(16)
			f[k]:SetHeight(16)
			f[k]:SetScript("OnMouseDown", ChatFrame_StartResizing)
			f[k]:SetScript("OnMouseUp", ChatFrame_StopResizing)
			LowerFrameLevel(f[k])
		end

		f.resizeTopLeft:SetPoint("TOPLEFT", f.background, -2, 2)

		f.resizeTopRight:SetPoint("TOPRIGHT", f.background, 2, 2)

		f.resizeBottomLeft:SetPoint("BOTTOMLEFT", f.background, -2, -3)

		f.resizeBottomRight:SetPoint("BOTTOMRIGHT", f.background, 2, -3)

		f.resizeTop:SetPoint("LEFT", f.resizeTopLeft, "RIGHT", 0, 0)
		f.resizeTop:SetPoint("RIGHT", f.resizeTopRight, "LEFT", 0, 0)

		f.resizeRight:SetPoint("TOP", f.resizeTopRight, "BOTTOM", 0, 0)
		f.resizeRight:SetPoint("BOTTOM", f.resizeBottomRight, "TOP", 0, 0)

		f.resizeBottom:SetPoint("LEFT", f.resizeBottomLeft, "RIGHT", 0, 0)
		f.resizeBottom:SetPoint("RIGHT", f.resizeBottomRight, "LEFT", 0, 0)

		f.resizeLeft:SetPoint("TOP", f.resizeTopLeft, "BOTTOM", 0, 0)
		f.resizeLeft:SetPoint("BOTTOM", f.resizeBottomLeft, "TOP", 0, 0)
	end

	local b = _G["ChatFrame"..i.."ResizeButton"]
	b:SetScript("OnShow", b.Hide)
	b:Hide()
end