﻿--玩家姓名染色,from PhanxChat,
local ShowLevel = AshChatDB.ShowLevel
local L = AshChat_Localize
local COLOR_UNKNOWN = nil
local PLAYER_STYLE = "[%s]"		-- %s = name
local CHANNEL_STYLE = "[%1|%2]" 	-- %1 = channel number, %2 = channel name

local URL_STYLE = "|cff00ccff%s|r"	-- %s = URL

local STRING_STYLE = "%s| %%s: "	-- %s = short string, %%s = player name
AshChat = CreateFrame("Frame")
local _G = getfenv(0)

local AshChat, self = AshChat, AshChat
--AshChat.version = tonumber(GetAddOnMetadata("AshChat", "Version"):match("(%d+)"))

AshChat.names = {}
AshChat.hooks = {}
AshChat.levels = {}

local names = AshChat.names
local hooks = AshChat.hooks
local levels = AshChat.levels

AshChatName = names
AshChatLevels = levels

local db, frame, button, icon, name, class, currentLink, _

db = {}
db = AshChatDB

local noop = function() end
local pairs = pairs
local select = select
local strformat = string.format
local GetFriendInfo = GetFriendInfo
local GetGuildRosterInfo = GetGuildRosterInfo
local GetNumFriends = GetNumFriends
local GetNumGuildMembers = GetNumGuildMembers
local GetNumPartyMembers = GetNumPartyMembers
local GetNumRaidMembers = GetNumRaidMembers
local GetNumWhoResults = GetNumWhoResults
local GetRaidRosterInfo = GetRaidRosterInfo
local GetWhoInfo = GetWhoInfo
local UnitClass = UnitClass
local UnitExists = UnitExists
local UnitIsFriend = UnitIsFriend
local UnitIsPlayer = UnitIsPlayer
local UnitName = UnitName
local UnitLevel = UnitLevel
local playername = UnitName("player")
local playerlevel = UnitLevel("player")
local realm = GetRealmName()
local function print(msg)		ChatFrame1:AddMessage("|cff00ddbaAshChat:|r "..msg)				end
local function printf(msg, ...)	ChatFrame1:AddMessage("|cff00ddbaAshChat:|r "..msg:format(...))	end

local HLlist = AshChat_HLL

local function debug(msg, ...)
	ChatFrame5:AddMessage("|cffff7f7fAsh:|r "..msg)
end


--local CLASS_COLORS = {}
--for k, v in pairs(RAID_CLASS_COLORS) do
--	CLASS_COLORS[k] = ("%02x%02x%02x"):format(v.r * 255, v.g * 255, v.b * 255)
--end

PLAYER_STYLE = "|Hplayer:%s|h"..PLAYER_STYLE.."|h"
local HL_STYLE = "|Hhl:%s|h"..URL_STYLE.."|h "
URL_STYLE = " |Hashurl:%s|h"..URL_STYLE.."|h "



local URL_PATTERNS = {
	{ "(%a+://%S+)", "%1" }, -- X://Y
	{ "(www%.[%w_%.%-]+%.%S+)", "%1" }, -- www.X.Y
	{ "([0-2]?%d?%d%.[0-2]?%d?%d%.[0-2]?%d?%d%.[0-2]?%d?%d:?%d-/?%S*)", "%1" }, -- A.B.C.D:N/X
	{ "([%w_%.%-]+[%w_%-]%.%a%a[GgMmOoTtUuVv]?[Oo]?:?[0-6]?%d-/?%S*)", "%1" }, -- X.Y
	{ "(%S+@[%w_%.%-]+%.%a+)", "%1" }, -- X@Y.Z
}

----------------------------------------------------------------

--[[------------------------------------------------------------
	AddMessage
	channels, names, urls
--------------------------------------------------------------]]

local MessageEvents = {
	"CHAT_MSG_SAY",
	"CHAT_MSG_YELL",
	"CHAT_MSG_WHISPER",
	"CHAT_MSG_WHISPER_INFORM",
	"CHAT_MSG_GUILD",
	"CHAT_MSG_OFFICER",
	"CHAT_MSG_PARTY",
	"CHAT_MSG_PARTY_LEADER",
	"CHAT_MSG_RAID",
	"CHAT_MSG_RAID_LEADER",
	"CHAT_MSG_RAID_WARNING",
	"CHAT_MSG_BATTLEGROUND",
	"CHAT_MSG_BATTLEGROUND_LEADER",
	"CHAT_MSG_CHANNEL",
	"CHAT_MSG_BG_SYSTEM_ALLIANCE",
	"CHAT_MSG_BG_SYSTEM_HORDE",
	"CHAT_MSG_BG_SYSTEM_NEUTRAL",
	"CHAT_MSG_EMOTE",
	"CHAT_MSG_TEXT_EMOTE",
	"CHAT_MSG_MONSTER_EMOTE",
	"CHAT_MSG_MONSTER_SAY",
	"CHAT_MSG_MONSTER_WHISPER",
	"CHAT_MSG_MONSTER_YELL",
	"CHAT_MSG_RAID_BOSS_EMOTE",

}
--local CurrEvent = nil
function Ash_GetColoredName(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12)
	local chatType = strsub(event, 10);
	if ( strsub(chatType, 1, 7) == "WHISPER" ) then
		chatType = "WHISPER";
	end
	if ( strsub(chatType, 1, 7) == "CHANNEL" ) then
		chatType = "CHANNEL"..arg8;
	end
	local info = ChatTypeInfo[chatType];
	
	if ( info and arg12 ~= "" ) then
		local localizedClass, englishClass, localizedRace, englishRace, sex = GetPlayerInfoByGUID(arg12)
		
		if ( englishClass ) then
			local classColorTable = RAID_CLASS_COLORS[englishClass];
			if ( not classColorTable ) then
				return arg2;
			end
			local levels = AshChat.levels
			if levels[arg2] and db.ShowLevel and (db.names or info.colorNameByClass) then
				local color = GetQuestDifficultyColor(levels[arg2])
				local lcolor = ("%02x%02x%02x"):format(color.r * 255 , color.g * 255 , color.b * 255 )
				local e = "|cff"..lcolor..levels[arg2].."|r"
				return e..":"..string.format("\124cff%.2x%.2x%.2x", classColorTable.r*255, classColorTable.g*255, classColorTable.b*255)..arg2.."\124r"
			elseif (db.names or info.colorNameByClass) then
				return string.format("\124cff%.2x%.2x%.2x", classColorTable.r*255, classColorTable.g*255, classColorTable.b*255)..arg2.."\124r"
			elseif levels[arg2] and db.ShowLevel then
				local color = GetQuestDifficultyColor(levels[arg2])
				local lcolor = ("%02x%02x%02x"):format(color.r * 255 , color.g * 255 , color.b * 255 )
				local e = "|cff"..lcolor..levels[arg2].."|r"
				return e..":"..arg2
			end
		end
	end
	
	return arg2;
end
local found = 0	
function Ash_DealMsg(self, event, msg, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15)
	found = 0
	if type(msg) == "string" then
		if event then
			if db.urls then
				local T = strsub(event, 10)				
				if (T ~= "RAID_WARNING") and (T ~= "EMOTE") and (T ~= "TEXT_EMOTE") and (strsub(T, 1, 7) ~= "MONSTER") and (T ~= "RAID_BOSS_EMOTE")then
					msg = msg.." "
					for i, v in ipairs(URL_PATTERNS) do
						if (not string.find(msg, "|Hashurl")) then
							msg = msg:gsub(v[1], URL_STYLE:format(v[2], v[2]))
						end
					end
				end
			end			
			if db.highlight then
				if AshChat_HLL and (arg2 ~= UnitName("player")) then
	--			if AshChat_HLL then
					local aword, bword
					for aword, bword in pairs(HLlist) do
						local HLsound = string.find(msg,".*("..bword..").*")
						if HLsound then
							msg = string.gsub(msg,"(.*)("..bword..")(.*)", "%1"..HL_STYLE:format("%2", "%2").."%3")
							PlaySoundFile("Interface\\AddOns\\AshChat\\audio\\hilite.mp3");
							found = found + 1
						end					
					end
				end
			end
		end		
	end
	return false, msg, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15
end
-- oChat, modifiered
--時間標簽,點擊復制此條消息


local type = type
local tonumber = tonumber
local string_split = string.split
local str = '%d|h %3$s' -- gives: 1 Otravi: Hi
--disable fade
for i = 1, NUM_CHAT_WINDOWS do
	local cf = _G['ChatFrame'..i]

	cf:SetFading(false)
end


local eb = ChatFrame1EditBox

--local a, b, c = select(6, eb:GetRegions())
--a:Hide();b:Hide();c:Hide()


-- Modified version of MouseIsOver from UIParent.lua
local MouseIsOver = function(frame)
	local s = frame:GetParent():GetEffectiveScale()
	local x, y = GetCursorPosition()
	x = x / s
	y = y / s

	local left = frame:GetLeft()
	local right = frame:GetRight()
	local top = frame:GetTop()
	local bottom = frame:GetBottom()

	-- Hack to fix a symptom not the real issue
	if(not left) then
		return
	end

	if((x > left and x < right) and (y > bottom and y < top)) then
		return 1
	else
		return
	end
end

local borderManipulation = function(...)
	for l = 1, select('#', ...) do
		local obj = select(l, ...)
		if(obj:GetObjectType() == 'FontString' and MouseIsOver(obj)) then
			return obj:GetText()
		end
	end
end

--频道缩写,鸣谢wchat
--if AshChatDB.ShortChannel then
if (GetLocale() == "zhCN") then

	CHAT_WHISPER_GET = "%s ->: "						--密入
	CHAT_WHISPER_INFORM_GET = "-> %s: "				--密出
	CHAT_SAY_GET = "%s: "							--說
	CHAT_YELL_GET = "%s大喊: "						--大喊
	CHAT_GUILD_GET = "[会] %s: "					--公會
	CHAT_RAID_GET = "[团] %s: "						--團隊
	CHAT_PARTY_GET = "[队] %s: "					--小隊
	CHAT_OFFICER_GET = "[官] %s: "					--官員
	CHAT_RAID_LEADER_GET = "[RL] %s: "				--團長
	CHAT_RAID_WARNING_GET = "[警] %s: "				--團隊警報
	CHAT_BATTLEGROUND_GET = "[战] %s: "				--戰場
	CHAT_BATTLEGROUND_LEADER_GET = "[将]%s: "		--戰場團長
	CHAT_PARTY_GUIDE_GET = "[导]%s: "				--地下城向导
	CHAT_PARTY_LEADER_GET = "[PL]%s: "				--队长(PARTY LEADER)
	CHAT_BN_WHISPER_GET = "%s ->:\32"				--实名密入	
	CHAT_BN_WHISPER_INFORM_GET = "-> %s:\32"		--实名密出
end
--end
local gsub = gsub
local newAddMsg = {}
local rplc = {
	"[GEN]", --General
	"[TR]", --Trade
	"[WD]", --WorldDefense
	"[LD]", --LocalDefense
	"[LFG]", --LookingForGroup
	"[GR]", --GuildRecruitment
}

local chn = {}

if (GetLocale() == "ruRU") then --Russian
	chn[1] = "%[%d0?%. Общий.-%]"
	chn[2] = "%[%d0?%. Торговля.-%]"
	chn[3] = "%[%d0?%. Оборона: глобальный%]" --Defense: Global
	chn[4] = "%[%d0?%. Оборона.-%]" --Defense: Zone
	chn[5] = "%[%d0?%. Поиск спутников%]"
	chn[6] = "%[%d0?%. Гильдии.-%]"
elseif (GetLocale() == "deDE") then --German
	chn[1] = "%[%d0?%. Allgemein.-%]"
	chn[2] = "%[%d0?%. Handel.-%]"
	chn[3] = "%[%d0?%. Weltverteidigung%]"
	chn[4] = "%[%d0?%. LokaleVerteidigung.-%]"
	chn[5] = "%[%d0?%. SucheNachGruppe%]"
	chn[6] = "%[%d0?%. Gildenrekrutierung.-%]"
elseif (GetLocale() == "frFR") then --French
	chn[1] = "%[%d0?%. Général.-%]"
	chn[2] = "%[%d0?%. Commerce.-%]"
	chn[3] = "%[%d0?%. DéfenseUniverselle%]"
	chn[4] = "%[%d0?%. DéfenseLocale.-%]"
	chn[5] = "%[%d0?%. RechercheDeGroupe%]"
	chn[6] = "%[%d0?%. RecrutementDeGuilde.-%]"
elseif (GetLocale() == "zhTW") then --Traditional Chinese
	chn[1] = "%[%d0?%. 綜合.-%]"
	chn[2] = "%[%d0?%. 交易.-%]"
	chn[3] = "%[%d0?%. 世界防務%]"
	chn[4] = "%[%d0?%. 本地防務.-%]"
	chn[5] = "%[%d0?%. 組隊%]"
	chn[6] = "%[%d0?%. 公會招募.-%]"
elseif (GetLocale() == "zhCN") then --Simplified Chinese
	chn[1] = "%[(%d0?%.) 综合.-%]"
	chn[2] = "%[(%d0?%.) 交易.-%]"
	chn[3] = "%[(%d0?%.) 世界防务%]"
	chn[4] = "%[(%d0?%.) 本地防务.-%]"
	chn[5] = "%[(%d0?%.) 寻求组队%]"
	chn[6] = "%[(%d0?%.) 公会招募.-%]"
	rplc[1] = "[%1综]"
	rplc[2] = "[%1易]"
	rplc[3] = "[%1世]"
	rplc[4] = "[%1本]"
	rplc[5] = "[%1寻]"
	rplc[6] = "[%1招]"
else
	chn[1] = "%[%d0?%. General.-%]"
	chn[2] = "%[%d0?%. Trade.-%]"
	chn[3] = "%[%d0?%. WorldDefense%]"
	chn[4] = "%[%d0?%. LocalDefense.-%]"
	chn[5] = "%[%d0?%. LookingForGroup%]"
	chn[6] = "%[%d0?%. GuildRecruitment.-%]"
end

if db.CustomChannel == nil then
	db.CustomChannel = {}
end
-------hook AddMessage------------
local AddMessage = function(frame, text, ...)
	local ts 
	if AshChatDB.TimeColor then
		ts = AshChatDB.TimeColor
	else
		ts = AshChat_defaults.TimeColor
	end
	if(type(text) == 'string') and db.Time then
--		text = text:gsub('|Hplayer:([^:]+):(%d+)|h%[(.-)%]|h', '|Hplayer:%1:%2|h%3|h')
--		text = text:gsub('%[(%d+)%. (.+)%].+(|Hplayer.+)', channel)
		if db.Second and db.Timequote then	--時間格式
			text = ts:format(date'[%H:%M:%S]', text)
		elseif db.Timequote then
			text = ts:format(date'[%H:%M]', text)
		elseif db.Second then
			text = ts:format(date'%H:%M:%S', text)
		else
			text = ts:format(date'%H:%M', text)	
		end										
	end
	if found == 1 and frame == ChatFrame1 and (not db.NoMiddle) then
		found = found + 1
		UIErrorsFrame:AddMessage(text, 1, 1, 1, 1.0, UIERRORS_HOLD_TIME)
	else
		found = 0
	end
	if db.ShortChannel then
		for i = 1, 6 do	
			text = string.gsub(text, chn[i], rplc[i])
		end
		for i, v in ipairs(db.CustomChannel) do
			text = string.gsub(text, "%[(%d0?%.) "..v[1].."%]", "[%1"..v[2].."]")
		end
	end
	--If Blizz timestamps is enabled, stamp anything it misses
--	text = string.gsub(text, "%[(%d0?)%. .-%]", "[%1]") --custom channels
	return newAddMsg[frame:GetName()](frame, text, ...)
end

for i = 1, 10 do
	local fcl = _G[format("%s%d", "ChatFrame", i)]
	--skip combatlog and frames with no messages registered
	newAddMsg[format("%s%d", "ChatFrame", i)] = fcl.AddMessage
	fcl.AddMessage = AddMessage
	if i == 2 then -- skip combatlog
		fcl.AddMessage = newAddMsg[format("%s%d", "ChatFrame", i)]
	end
end

function AshChat:RegisterName(name, level)
	if name then
		if level and level > 0 then
			levels[name] = level
		end
	end
	if level and levels[name] and (levels[name] ~= level) and (level ~= 0) then
		levels[name] = level
		debug("adding "..level.." "..name)
	end
end

function AshChat:PLAYER_LEVEL_UP(arg1, ...)
	local name, level
	name = UnitName("player")
	level = arg1
--	class = select(2, UnitClass("player"))
	levels[name] = level
--	playerlevel = level
end

function AshChat:FRIENDLIST_UPDATE()
	local name, level
	for i = 1, GetNumFriends() do
		name, level = GetFriendInfo(i)
		self:RegisterName(name, level)
	end
end

function AshChat:PLAYER_GUILD_UPDATE()
	if IsInGuild() then
		GuildRoster()
	end
end

function AshChat:GUILD_ROSTER_UPDATE()
	local name, level, unregister
	for i = 1, GetNumGuildMembers(true) do
		name, _, _, level = GetGuildRosterInfo(i)
		self:RegisterName(name, level)
		unregister = true
	end
	if unregister then
		self:UnregisterEvent("PLAYER_GUILD_UPDATE")
		self:UnregisterEvent("GUILD_ROSTER_UPDATE")
	end
end

function AshChat:PARTY_MEMBERS_CHANGED()
	local name, level, unit, server, fullname
	for i = 1, GetNumPartyMembers() do
		unit = "party" .. i
		name, server = UnitName(unit)
		level = UnitLevel(unit)
		fullname = name..(server and server:len()>0 and ("-"..server) or "")
		if server == realm then
			self:RegisterName(name, level)
		else
			self:RegisterName(fullname, level)
		end
	end
--	debug("PARTYadding "..class.." "..name) --debug
end

function AshChat:RAID_ROSTER_UPDATE()
	if MiniMapBattlefieldFrame.status == "active" then
		for i = 1, GetNumBattlefieldScores() do
			local BGname, killingBlows, honorKills, deaths, honorGained, faction, rank, race, class, filename, damageDone, healingDone = GetBattlefieldScore(i);
			if BGname then
				self:RegisterName(BGname, nil)
			end
		end
	end
	local name, level, unit, fullname
	for i = 1, GetNumRaidMembers() do
		_, _, _, level = GetRaidRosterInfo(i)
		unit = "raid" .. i
		name, server = UnitName(unit)
		fullname = name..(server and server:len()>0 and ("-"..server) or "")
		if server == realm then
			self:RegisterName(name, level)
		else
			self:RegisterName(fullname, level)
		end
	end
end

function AshChat:PLAYER_TARGET_CHANGED()
	local name, level
	if UnitExists("target") and UnitIsPlayer("target") and UnitIsFriend("player", "target") then	--debug
		name, server = UnitName("target")
--	class = select(2, UnitClass("target"))
		level = UnitLevel("target")
		fullname = name..(server and server:len()>0 and ("-"..server) or "")
		if server == realm then
			self:RegisterName(name, level)
		else
			self:RegisterName(fullname, level)
		end
--		debug("Target adding "..class.." "..name)	--debug
	end
end

function AshChat:UPDATE_MOUSEOVER_UNIT()
	local name, level
	if UnitExists("mouseover") and UnitIsPlayer("mouseover") and UnitIsFriend("player", "mouseover") then	--debug
		name, server = UnitName("mouseover")
--	class = select(2, UnitClass("mouseover"))
		level = UnitLevel("mouseover")
		fullname = name..(server and server:len()>0 and ("-"..server) or "")
		if server == realm then
			self:RegisterName(name, level)
		else
			self:RegisterName(fullname, level)
		end
--		debug("Mouse adding "..class.." "..name)	--debug
	end
end

function AshChat:WHO_LIST_UPDATE()
	local name, class, level
	for i = 1, GetNumWhoResults() do
		name, _, level = GetWhoInfo(i)
		self:RegisterName(name, level)
	end
end

function AshChat:CHAT_MSG_SYSTEM(message)
	if message:match("^%|Hplayer:") then
		self:WHO_LIST_UPDATE()
	end
end

--------------------------------------------------------------------------------------

--[[------------------------------------------------------------
	hook ItemRef
--------------------------------------------------------------]]

function AshChat.SetItemRef(link, text, button, ...)
	if(link:sub(1, 5) == 'yChat') then
		local text = borderManipulation(SELECTED_CHAT_FRAME:GetRegions())
		if(text) then
			text = text:gsub('|c%x%x%x%x%x%x%x%x(.-)|r', '%1')
			text = text:gsub('|H.-|h(.-)|h', '%1')

			eb:Insert(text)
			eb:Show()
			eb:HighlightText()
			eb:SetFocus()
		end
		return
	end
	if link:sub(1, 6) == "ashurl" then
	--	URLCopyDialog_Show(link:sub(5))
	--	local currentLink = link:sub(8)
		local eb = ChatFrame1EditBox
		eb:Insert(text)
		eb:Show()
		eb:HighlightText()
		eb:SetFocus()
		return
	end
	if link:sub(1, 2) == "hl" and button == "RightButton" and IsControlKeyDown() then
		local aword, bword
		for aword, bword in pairs(HLlist) do
			if string.find(link, bword) then
				HLlist[aword] = nil;
				print("關鍵詞<"..bword..">已禁用")
			end
		end
		return
	end
	if link:sub(1, 2) == "hl" then
		printf("Ctrl+右键点击以屏蔽此关键词,使其不再高亮")
		return
	end
	hooks.SetItemRef(link, text, button, ...)
end

function AshChat.HighReset()
	HLlist = AshChat_HLL
end

local function TellTarget(msg)
	if UnitExists("target") and UnitIsPlayer("target") and (UnitIsFriend("player", "target") or UnitIsCharmed("target")) then
		SendChatMessage(msg, "WHISPER", nil, UnitName("target"))
	end
end

--[[------------------------------------------------------------
	Initialize
--------------------------------------------------------------]]
function AshChat:RefreshArg()
	db = AshChatDB
	AshChat_Top(db.InputTop)
	ChatFrame1EditBox:SetAltArrowKeyMode(db.ALT)
	AshChat_FMB(db.showfmb)
end

function AshChat_Panel_Okay(panel)
	if panel == "LEVEL" then
		db.ShowLevel = AshChat_Panel_Level:GetChecked()
	elseif panel == "NAMECOLOR" then
		db.names = AshChat_Panel_Namecolor:GetChecked()
	elseif panel == "URL" then
		db.urls = AshChat_Panel_URL:GetChecked()
	elseif panel == "HIGHLIGHT" then
		db.highlight = AshChat_Panel_HIGHLIGHT:GetChecked()
	elseif panel == "HIGHMIDDLE" then
		if (AshChat_Panel_HIGHMIDDLE:GetChecked()) then
			db.NoMiddle = false
		else
			db.NoMiddle = true
		end
	elseif panel == "HIGHRESET" then
		AshChat.HighReset()
	elseif panel == "SHORT" then
		db.ShortChannel = AshChat_Panel_SHORT:GetChecked()
	elseif panel == "INPUTTOP" then
		db.InputTop = AshChat_Panel_INPUTTOP:GetChecked()
		AshChat_Top(AshChat_Panel_INPUTTOP:GetChecked())
	elseif panel == "WISPERSOUND" then
		db.WhisperSound = AshChat_Panel_WISPERSOUND:SetChecked()
	elseif panel == "OTHERSOUND" then
		db.OtherChannelSound = AshChat_Panel_OTHERSOUND:GetChecked()
	elseif panel == "STICKY" then
		db.Sticky = AshChat_Panel_STICKY:GetChecked()
	elseif panel == "NOALT" then
		db.ALT = (not AshChat_Panel_NOALT:GetChecked())
		ChatFrameEditBox:SetAltArrowKeyMode(db.ALT)
	elseif panel == "TIME" then
		db.Time = AshChat_Panel_TIME:GetChecked()
	elseif panel == "TIMESEC" then
		db.Second = AshChat_Panel_TIMESEC:GetChecked()
	elseif panel == "TIMEQUOTE" then
		db.Timequote = AshChat_Panel_TIMEQUOTE:GetChecked()
	elseif panel == "FRIENDS" then
		db.showfmb = (not AshChat_Panel_FRIENDS:GetChecked())
		AshChat_FMB(db.showfmb)
	elseif panel == "TIMECOLOR" then
		local r, g, b = ColorPickerFrame:GetColorRGB()
		local hex = ("%02x%02x%02x"):format(r * 255 , g * 255 , b * 255 )
		db.TimeColor = '|cff'..hex..'|HyChat|h%s|h|r %s'
		db.TimeColor2 = {r, g, b}
		AshChat_Panel_TIMECOLOR:GetNormalTexture():SetVertexColor(db.TimeColor2[1], db.TimeColor2[2], db.TimeColor2[3]);
	elseif panel == "SHORT" then
		db.ShortChannel = AshChat_Panel_SHORT:GetChecked()
	elseif panel == "CANCEL" then
		AshChat:RefreshArg()
	elseif panel == "DEFAULT" then
		StaticPopup_Show("ASHCHAT_RESETWARNING")
	elseif panel == "ENTER" then
		AshChatDB = db
	end
	AshChat_Panel_UpdateViews()
end
local function DropDown_SetSelect(frame, value)
	if frame and frame:IsVisible() and value then
		ToggleDropDownMenu(1, nil, frame)
		UIDropDownMenu_SetSelectedValue(frame, value)
		ToggleDropDownMenu(1, nil, frame)
	end
end

local function UpdateCCLIST()
	local msg = ""
	for i, v in ipairs(db.CustomChannel) do
		if v ~= nil then 
		msg = msg..i..". "..v[1].."  ->  "..v[2].."\n"
		end
	end
	AshChat_Panel_CCLIST:SetText(msg)
end
local function UpdateCCMENU(ad1, ad2)
	local n = table.getn(db.CustomChannel)
	for i = 1, n do
		if db.CustomChannel[i] ~= nil then 
		UIDropDownMenu_AddButton({value = i, text = i, func = function(self) DropDown_SetSelect(AshChat_Panel_CCMENU, i) ad1:SetText(db.CustomChannel[i][1]) ad2:SetText(db.CustomChannel[i][2]) end, checked = nil}, 1); 
		end
	end
end
local function settip(frame, text)
	frame:SetScript("OnEnter",function(frame)
		GameTooltip:SetOwner(frame, "ANCHOR_RIGHT");
		GameTooltip:SetText(text, 1, 1, 1, nil, 1);	
	end)
	frame:SetScript("OnLeave",function()
		GameTooltip:Hide();
	end)
end
function AshChat_Settings_Default()	
	db = AshChat_defaults
	AshChatDB = AshChat_defaults
	AshChat:RefreshArg()
	UpdateCCLIST()
	UpdateCCMENU(ADDCH1, ADDCH2)
end



function AshChat_Panel_Options()
	AshChat_Panel_Namecolor = CreateFrame("CheckButton", "AshChat_Panel_Namecolor", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_Namecolor:SetPoint("TOPLEFT", 16, -16)
	AshChat_Panel_NamecolorText:SetText(L.NAMECOLOR)
	AshChat_Panel_Namecolor:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("NAMECOLOR")
		end
	)
	settip(AshChat_Panel_Namecolor, L.NAMECOLOR_TIP)
	
	AshChat_Panel_Level = CreateFrame("CheckButton", "AshChat_Panel_Level", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_Level:SetPoint("TOPLEFT", "AshChat_Panel_Namecolor", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_LevelText:SetText(L.LEVEL)
	AshChat_Panel_Level:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("LEVEL")
		end
	)
	settip(AshChat_Panel_Level, L.LEVEL_TIP)
	
	AshChat_Panel_URL = CreateFrame("CheckButton", "AshChat_Panel_URL", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_URL:SetPoint("TOPLEFT", "AshChat_Panel_Level", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_URLText:SetText(L.URL)
	AshChat_Panel_URL:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("URL")
		end
	)
	settip(AshChat_Panel_URL, L.URL_TIP)

	AshChat_Panel_HIGHLIGHT = CreateFrame("CheckButton", "AshChat_Panel_HIGHLIGHT", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_HIGHLIGHT:SetPoint("TOPLEFT", "AshChat_Panel_URL", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_HIGHLIGHTText:SetText(L.HIGHLIGHT)
	AshChat_Panel_HIGHLIGHT:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("HIGHLIGHT")
		end
	)
	settip(AshChat_Panel_HIGHLIGHT, L.HIGHLIGHT_TIP)

	AshChat_Panel_HIGHMIDDLE = CreateFrame("CheckButton", "AshChat_Panel_HIGHMIDDLE", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_HIGHMIDDLE:SetPoint("TOPLEFT", "AshChat_Panel_HIGHLIGHT", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_HIGHMIDDLEText:SetText(L.HIGHMIDDLE)
	AshChat_Panel_HIGHMIDDLE:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("HIGHMIDDLE")
		end
	)
	settip(AshChat_Panel_HIGHMIDDLE, L.HIGHMIDDLE_TIP)

	AshChat_Panel_HIGHRESET = CreateFrame("Button", "AshChat_Panel_HIGHRESET", AshChat_Panel, "UIPanelButtonTemplate")
	AshChat_Panel_HIGHRESET:SetWidth(120);
	AshChat_Panel_HIGHRESET:SetHeight(20);
	AshChat_Panel_HIGHRESET:SetPoint("BOTTOMLEFT", 10, 10)
	AshChat_Panel_HIGHRESET:SetText(L.HIGHRESET)
	AshChat_Panel_HIGHRESET:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("HIGHRESET")
		end
	)
	settip(AshChat_Panel_HIGHRESET, L.HIGHRESET_TIP)

	AshChat_Panel_DEFAULT = CreateFrame("Button", "AshChat_Panel_DEFAULT", AshChat_Panel, "UIPanelButtonTemplate")
	AshChat_Panel_DEFAULT:SetWidth(120);
	AshChat_Panel_DEFAULT:SetHeight(20);
	AshChat_Panel_DEFAULT:SetPoint("BOTTOMRIGHT", -10, 10)
	AshChat_Panel_DEFAULT:SetText(L.DEFAULT)
	AshChat_Panel_DEFAULT:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("DEFAULT")
		end
	)
	settip(AshChat_Panel_DEFAULT, L.DEFAULT_TIP)

	AshChat_Panel_SHORT = CreateFrame("CheckButton", "AshChat_Panel_SHORT", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_SHORT:SetPoint("TOPLEFT", "AshChat_Panel_HIGHMIDDLE", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_SHORTText:SetText(L.SHORT)
	AshChat_Panel_SHORT:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("SHORT")
		end
	)
	settip(AshChat_Panel_SHORT, L.SHORT_TIP)

	AshChat_Panel_INPUTTOP = CreateFrame("CheckButton", "AshChat_Panel_INPUTTOP", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_INPUTTOP:SetPoint("TOPLEFT", "AshChat_Panel_SHORT", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_INPUTTOPText:SetText(L.INPUTTOP)
	AshChat_Panel_INPUTTOP:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("INPUTTOP")
		end
	)
	settip(AshChat_Panel_INPUTTOP, L.INPUTTOP_TIP)

	AshChat_Panel_WISPERSOUND = CreateFrame("CheckButton", "AshChat_Panel_WISPERSOUND", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_WISPERSOUND:SetPoint("TOPLEFT", "AshChat_Panel_INPUTTOP", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_WISPERSOUNDText:SetText(L.WISPERSOUND)
	AshChat_Panel_WISPERSOUND:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("WISPERSOUND")
		end
	)
	settip(AshChat_Panel_WISPERSOUND, L.WISPERSOUND_TIP)

	AshChat_Panel_OTHERSOUND = CreateFrame("CheckButton", "AshChat_Panel_OTHERSOUND", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_OTHERSOUND:SetPoint("TOPLEFT", "AshChat_Panel_WISPERSOUND", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_OTHERSOUNDText:SetText(L.OTHERSOUND)
	AshChat_Panel_OTHERSOUND:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("OTHERSOUND")
		end
	)
	settip(AshChat_Panel_OTHERSOUND, L.OTHERSOUND_TIP)

	AshChat_Panel_STICKY = CreateFrame("CheckButton", "AshChat_Panel_STICKY", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_STICKY:SetPoint("TOPLEFT", "AshChat_Panel_OTHERSOUND", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_STICKYText:SetText(L.STICKY)
	AshChat_Panel_STICKY:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("STICKY")
		end
	)
	settip(AshChat_Panel_STICKY, L.STICKY_TIP)

	AshChat_Panel_NOALT = CreateFrame("CheckButton", "AshChat_Panel_NOALT", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_NOALT:SetPoint("TOPLEFT", "AshChat_Panel_STICKY", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_NOALTText:SetText(L.NOALT)
	AshChat_Panel_NOALT:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("NOALT")
		end
	)
	settip(AshChat_Panel_NOALT, L.NOALT_TIP)

	AshChat_Panel_TIME = CreateFrame("CheckButton", "AshChat_Panel_TIME", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_TIME:SetPoint("TOPLEFT", 200, -16)
	AshChat_Panel_TIMEText:SetText(L.TIME)
	AshChat_Panel_TIME:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("TIME")
		end
	)
	settip(AshChat_Panel_TIME, L.TIME_TIP)

	AshChat_Panel_TIMESEC = CreateFrame("CheckButton", "AshChat_Panel_TIMESEC", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_TIMESEC:SetPoint("TOPLEFT", "AshChat_Panel_TIME", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_TIMESECText:SetText(L.TIMESEC)
	AshChat_Panel_TIMESEC:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("TIMESEC")
		end
	)
	settip(AshChat_Panel_TIMESEC, L.TIMESEC_TIP)

	AshChat_Panel_TIMEQUOTE = CreateFrame("CheckButton", "AshChat_Panel_TIMEQUOTE", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_TIMEQUOTE:SetPoint("TOPLEFT", "AshChat_Panel_TIMESEC", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_TIMEQUOTEText:SetText(L.TIMEQUOTE)
	AshChat_Panel_TIMEQUOTE:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("TIMEQUOTE")
		end
	)
	settip(AshChat_Panel_TIMEQUOTE, L.TIMEQUOTE_TIP)

	AshChat_Panel_FRIENDS = CreateFrame("CheckButton", "AshChat_Panel_FRIENDS", AshChat_Panel, "OptionsCheckButtonTemplate")
	AshChat_Panel_FRIENDS:SetPoint("TOPLEFT", "AshChat_Panel_NOALT", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_FRIENDSText:SetText(L.FRIENDS)
	AshChat_Panel_FRIENDS:SetScript("OnClick",
		function(self)
			AshChat_Panel_Okay("FRIENDS")
		end
	)
	settip(AshChat_Panel_FRIENDS, L.FRIENDS_TIP)

	
	AshChat_Panel_TIMECOLOR = CreateFrame("Button", "AshChat_Panel_TIMECOLOR", AshChat_Panel)
	AshChat_Panel_TIMECOLOR:SetNormalTexture("Interface/ChatFrame/ChatFrameColorSwatch");
	AshChat_Panel_TIMECOLOR:SetWidth(20);
	AshChat_Panel_TIMECOLOR:SetHeight(20);
	AshChat_Panel_TIMECOLOR:SetPoint("TOPLEFT", "AshChat_Panel_TIMEQUOTE", "BOTTOMLEFT", 0, -4)
	AshChat_Panel_TIMECOLOR:SetScript("OnClick",function(self)
		ColorPickerFrame.func = function() AshChat_Panel_Okay("TIMECOLOR"); end
		ColorPickerFrame.hasOpacity = false;
		ColorPickerFrame.previousValues = {AshChatDB.TimeColor2[1], AshChatDB.TimeColor2[2], AshChatDB.TimeColor2[2]}; 
		ColorPickerFrame:SetColorRGB(db.TimeColor2[1], db.TimeColor2[2], db.TimeColor2[3]); 
		ShowUIPanel(ColorPickerFrame);			
	end)
	AshChat_Panel_TIMECOLOR:SetScript("OnShow", function(self)
		self:GetNormalTexture():SetVertexColor(db.TimeColor2[1], db.TimeColor2[2], db.TimeColor2[3]);
	end)
	settip(AshChat_Panel_TIMECOLOR, L.TIMECOLOR_TIP)

	
	local timecolortext = AshChat_Panel_TIMECOLOR:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	timecolortext:SetJustifyH("LEFT");
	timecolortext:SetHeight(30);
	timecolortext:SetPoint("LEFT", "AshChat_Panel_TIMECOLOR", "RIGHT", 0, 0 )
	timecolortext:SetText(L.TIMECOLOR)
	
	
	AshChat_Panel_BUTTON = CreateFrame("Frame", "AshChat_Panel_BUTTON", AshChat_Panel, "UIDropDownMenuTemplate")
	UIDropDownMenu_SetWidth(AshChat_Panel_BUTTON, 100);
	UIDropDownMenu_Initialize(AshChat_Panel_BUTTON, function(self)
		UIDropDownMenu_AddButton({value = 0, text = L.BUTTON_0, func = function(self) DropDown_SetSelect(AshChat_Panel_BUTTON, 0) AshChatDB.ButtonStyle = 0 Ash_ButtonLoad() end, checked = nil}, 1);
		UIDropDownMenu_AddButton({value = 1, text = L.BUTTON_1, func = function(self) DropDown_SetSelect(AshChat_Panel_BUTTON, 1) AshChatDB.ButtonStyle = 1 Ash_ButtonLoad() end, checked = nil}, 1);
		UIDropDownMenu_AddButton({value = 2, text = L.BUTTON_2, func = function(self) DropDown_SetSelect(AshChat_Panel_BUTTON, 2) AshChatDB.ButtonStyle = 2 Ash_ButtonLoad() end, checked = nil}, 1);
	end)
	AshChat_Panel_BUTTON:SetScript("OnShow", function(self)
		DropDown_SetSelect(self, db.ButtonStyle);
	end);
	AshChat_Panel_BUTTON:SetPoint("TOPLEFT", "AshChat_Panel_TIMECOLOR", "BOTTOMLEFT", 0, -30)
	settip(AshChat_Panel_BUTTON, L.BUTTON_TIP)

	
	local buttontext = AshChat_Panel_BUTTON:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	buttontext:SetWidth(100);
	buttontext:SetHeight(30);
	buttontext:SetPoint("TOPLEFT", "AshChat_Panel_TIMECOLOR", "BOTTOMLEFT", 0, -4)
	buttontext:SetText(L.BUTTON)

	
	AshChat_Panel_CHNCFG = CreateFrame("Frame", "AshChat_Panel_CHNCFG", UIParent);
	AshChat_Panel_CHNCFG.name = L.CHNCFG; 
    AshChat_Panel_CHNCFG.parent = "AshChat";
	AshChat_Panel_CHNCFG.okay = function (self) AshChat_Panel_Okay("ENTER"); end;
	AshChat_Panel_CHNCFG.cancel = function (self) AshChat_Panel_Okay("CANCEL"); end;
	AshChat_Panel_CHNCFG.default = function (self) AshChat_Panel_Okay("DEFAULT"); AshChat_Settings_Default(); AshChat_Panel_UpdateViews(); end;
	InterfaceOptions_AddCategory(AshChat_Panel_CHNCFG);
	
	local HEAD = AshChat_Panel_CHNCFG:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	HEAD:SetWidth(120);
	HEAD:SetHeight(30);
	HEAD:SetPoint("TOPLEFT", "AshChat_Panel_CHNCFG", 120, -16)
	HEAD:SetText(L.CUSTOMSHORT)
	AshChat_Panel_CCLIST = AshChat_Panel_CHNCFG:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	AshChat_Panel_CCLIST:SetWidth(200);
	AshChat_Panel_CCLIST:SetHeight(200);
	AshChat_Panel_CCLIST:SetPoint("TOPLEFT", "AshChat_Panel_CHNCFG", 90, -46)

	
	
	local ADDCH1 = CreateFrame("EditBox", "AshChat_ADDCH1", AshChat_Panel_CHNCFG, "InputBoxTemplate");
	ADDCH1:SetAutoFocus(nil);
	ADDCH1:SetWidth(135);
	ADDCH1:SetHeight(23);
	ADDCH1:SetPoint("BOTTOMLEFT", 16, 16);
	local ADDCH2 = CreateFrame("EditBox", "AshChat_ADDCH2", AshChat_Panel_CHNCFG, "InputBoxTemplate");
	ADDCH2:SetAutoFocus(nil);
	ADDCH2:SetWidth(135);
	ADDCH2:SetHeight(23);
	ADDCH2:SetPoint("BOTTOMLEFT", 160, 16);
	
	AshChat_Panel_ADDBUTTON = CreateFrame("Button", "AshChat_Panel_ADDBUTTON", AshChat_Panel_CHNCFG, "UIPanelButtonTemplate")
	AshChat_Panel_ADDBUTTON:SetWidth(50);
	AshChat_Panel_ADDBUTTON:SetHeight(23);
	AshChat_Panel_ADDBUTTON:SetPoint("BOTTOMLEFT", 300, 16)
	AshChat_Panel_ADDBUTTON:SetText(L.YES);
	AshChat_Panel_ADDBUTTON:SetScript("OnClick", function()
		local v1, v2 = ADDCH1:GetText(), ADDCH2:GetText()
		if (v1 ~= "") and (v2 ~= "") then
			local duplicate = nil
			for i, v in ipairs(db.CustomChannel) do
				if v[1] == v1 then 
					v[2] = v2
					duplicate = true
				end
			end
			if not duplicate then
				local n = table.getn(db.CustomChannel) + 1
				db.CustomChannel[n] = { v1, v2 }
			end
		end
		ADDCH1:ClearFocus();
		ADDCH2:ClearFocus();
		ADDCH1:SetText("");
		ADDCH2:SetText("");
		UpdateCCLIST();
		UpdateCCMENU(ADDCH1, ADDCH2)
	end)
	settip(AshChat_Panel_ADDBUTTON, L.ADDBUTTON_TIP)

	
	local AshChat_Panel_CLEARBUTTON = CreateFrame("Button", "AshChat_Panel_CLEARBUTTON", AshChat_Panel_CHNCFG, "UIPanelButtonTemplate")
	AshChat_Panel_CLEARBUTTON:SetWidth(50);
	AshChat_Panel_CLEARBUTTON:SetHeight(23);
	AshChat_Panel_CLEARBUTTON:SetText(L.CLEAR)
	AshChat_Panel_CLEARBUTTON:SetPoint("BOTTOMLEFT", 350, 16)
	AshChat_Panel_CLEARBUTTON:SetScript("OnClick",function()
		ADDCH1:SetText("");
		ADDCH2:SetText("");
		ADDCH1:ClearFocus();
		ADDCH2:ClearFocus();
	end)
	settip(AshChat_Panel_CLEARBUTTON, L.CLEARBUTTON_TIP)

	local LISTHEAD = AshChat_Panel_CHNCFG:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	LISTHEAD:SetWidth(150);
	LISTHEAD:SetHeight(30);
	LISTHEAD:SetPoint("BOTTOMLEFT", "AshChat_Panel_CHNCFG", 50, 46)
	LISTHEAD:SetText(L.CHOOSECHANNEL)

	AshChat_Panel_CCMENU = CreateFrame("Frame", "AshChat_Panel_CCMENU", AshChat_Panel_CHNCFG, "UIDropDownMenuTemplate")
	UIDropDownMenu_SetWidth(AshChat_Panel_CCMENU, 50);
	UIDropDownMenu_Initialize(AshChat_Panel_CCMENU, function()
		UpdateCCMENU(ADDCH1, ADDCH2)
	end)
	AshChat_Panel_CCMENU:SetScript("OnShow", function(self)
		DropDown_SetSelect(self, 1);
	end);
	AshChat_Panel_CCMENU:SetPoint("BOTTOMLEFT", 200, 46)
	
	local DEL = CreateFrame("Button", nil, AshChat_Panel_CHNCFG, "UIPanelButtonTemplate")
	DEL:SetWidth(50);
	DEL:SetHeight(23);
	DEL:SetText(L.DEL)
	DEL:SetPoint("LEFT", "AshChat_Panel_CCMENU", "RIGHT", 1, 0)
	DEL:SetScript("OnClick",function()
		local val = UIDropDownMenu_GetSelectedValue(AshChat_Panel_CCMENU);
		table.remove(db.CustomChannel, val);
		UpdateCCLIST();
		UpdateCCMENU(ADDCH1, ADDCH2)
	end)
	settip(DEL, L.DEL_TIP)


end

function AshChat_Panel_UpdateViews()
	AshChat_Panel_Namecolor:SetChecked(db.names)
	AshChat_Panel_Level:SetChecked(db.ShowLevel)
	AshChat_Panel_URL:SetChecked(db.urls)
	AshChat_Panel_HIGHLIGHT:SetChecked(db.highlight)
	AshChat_Panel_HIGHMIDDLE:SetChecked(not db.NoMiddle)
	AshChat_Panel_URL:SetChecked(db.urls)
	AshChat_Panel_SHORT:SetChecked(db.ShortChannel)
	AshChat_Panel_INPUTTOP:SetChecked(db.InputTop)
	AshChat_Panel_WISPERSOUND:SetChecked(db.WhisperSound)
	AshChat_Panel_OTHERSOUND:SetChecked(db.OtherChannelSound)
	AshChat_Panel_STICKY:SetChecked(db.Sticky)
	AshChat_Panel_NOALT:SetChecked(not db.ALT)
	AshChat_Panel_TIME:SetChecked(db.Time)
	AshChat_Panel_TIMESEC:SetChecked(db.Second)
	AshChat_Panel_TIMEQUOTE:SetChecked(db.Timequote)
	AshChat_Panel_FRIENDS:SetChecked(not db.showfmb)
	AshChat_Panel_SHORT:SetChecked(db.ShortChannel)
end

function AshChat_Panel_OnLoad(AshChat_Panel)
	AshChat_Panel.name = "AshChat"
	AshChat_Panel.okay = function (self) AshChat_Panel_Okay("ENTER"); end;
	AshChat_Panel.cancel = function (self) AshChat_Panel_Okay("CANCEL"); end;
	AshChat_Panel.default = function (self) AshChat_Panel_Okay("DEFAULT"); AshChat_Settings_Default(); AshChat_Panel_UpdateViews(); end;
	InterfaceOptions_AddCategory(AshChat_Panel)
end

function AshChat:VARIABLES_LOADED()

	if not db then
		--debug("Initializing new settings")
		db = AshChat_defaults
	else
		db = AshChatDB
		if not db.version or type(db.version) ~= "number" then
			-- really ancient!
			db.version = 0
		end
	end
	db.TimeColor2 = AshChatDB.TimeColor2 or { 255, 255, 255 }
	AshChatDB.TimeColor2 = db.TimeColor2
	for i = 1, 7 do
		frame = _G["ChatFrame"..i]
		if not hooks[frame] then hooks[frame] = {} end
		frame:SetMaxLines(250)
		frame:SetMaxResize(1600, 1200)
		frame:SetMinResize(64, 32)
		if i == 2 then
			hooks[frame].AddMessage = frame.AddMessage
		else
			hooks[frame].AddMessage = AddMessage
		end
	end
	for _, event in ipairs(MessageEvents) do
		ChatFrame_AddMessageEventFilter(event, Ash_DealMsg)
	end
	Ash_GetColoredNameOrg = GetColoredName
	GetColoredName = Ash_GetColoredName
	if db.names then
		self:RegisterEvent("FRIENDLIST_UPDATE")
		self:RegisterEvent("PLAYER_GUILD_UPDATE") -- workaround for people who don't get guild info immediately
		self:RegisterEvent("GUILD_ROSTER_UPDATE")
		self:RegisterEvent("PARTY_MEMBERS_CHANGED")
		self:RegisterEvent("RAID_ROSTER_UPDATE")
		self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
		self:RegisterEvent("PLAYER_TARGET_CHANGED")
		self:RegisterEvent("WHO_LIST_UPDATE")
		self:RegisterEvent("CHAT_MSG_SYSTEM")
		self:RegisterEvent("PLAYER_LEVEL_UP")

		AshChat:RegisterName(playername, playerlevel)

		if GetNumFriends() > 0 then
			ShowFriends()
		end

		if IsInGuild() then
			GuildRoster()
		end
	end
	if db.urls then
		hooks.SetItemRef = SetItemRef
		SetItemRef = AshChat.SetItemRef
	end
	StaticPopupDialogs["ASHCHAT_RESETWARNING"] = {
		text = L.DEFAULT_WARN,
		button1 = L.YES,
		button2 = L.NO,
		OnAccept = function()
		  AshChat_Settings_Default();
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	};
	
	AshChat_Panel_Options()
	AshChat_Panel_UpdateViews()
	UpdateCCLIST()
end



AshChat:SetScript("OnEvent", function(self, event, ...)
	if self[event] then
		--debug("Handling event "..event)
		self[event](self, ...)
	else
		--debug("No handler found for event "..event)
		self:UnregisterEvent(event)
	end
end)

AshChat:RegisterEvent("VARIABLES_LOADED")